#include   "common.h"
using namespace common;

#define    WindowX      1024
#define    WindowY      768
#define    ScreenX      WindowX
#define    ScreenY      WindowY
double     g_time       = 0;
glDevice   gl;
KeyState   key;

//test
#define    TEST_MAX     1024
struct obj {
  vec pos, dir;
  float angle;
  float dangle;
  void move() {
    pos += dir;
    angle += dangle;
    if(pos.x > ScreenX || pos.x < 0) dir.x = -dir.x;
    if(pos.y > ScreenY || pos.y < 0) dir.y = -dir.y;
  }
};
obj        testpos[TEST_MAX];


//-------//-------//-------//-------//-------//-------//-------//-------//-------//-------
// func
//-------//-------//-------//-------//-------//-------//-------//-------//-------//-------
void func_init(glDevice *device) {
  random rnd;
  obj *w = testpos;
  for(auto i = 0 ; i < TEST_MAX; i++) {
    w->pos = vec(abs(rnd.get()) % WindowX, abs(rnd.get()) % WindowY);
    w->dir = vec(rnd.fget(), rnd.fget());
    w->dangle = rnd.fget() * 12;
    w++;
  }
}

void draw_obj(glDevice *device, obj &p) {
  device->DrawDisk(p.pos.x, p.pos.y,  4, 8, p.angle, 16, 0, 64, 1.0);
  device->DrawDisk(p.pos.x, p.pos.y,  8, 4, p.angle, 16, 1, 64, 1.0);

}

void func_update(double g_time) {
  key.Update();
  for(auto i = 1 ; i < TEST_MAX; i++) testpos[i].move();
  obj *w = testpos;
  printf("%d %d %d %d\n", key.V, key.H, key.b0, key.b1);
  w->dir.x += key.H << 2;
  w->dir.y -= key.V << 2;
  w->move();
  w->dir = vec();
}

void func_term(glDevice *device) {
}

void func_render(glDevice *device) {
  //device->Clear(0.5, 0.5, 0.5, 0.5);
  device->Clear();
  device->DrawGrid(32, g_time * 30, g_time * 50, 128);
  for(auto i = 1 ; i < TEST_MAX; i++) draw_obj(device, testpos[i]);
  obj *w = testpos;
  device->DrawDisk(w->pos.x, w->pos.y, 32, 32, w->angle, 16, 1, 64, 1.0);
  device->DrawText("glDevice Test.", -1, 0,  0, 24, 24, 0.0, 240, FALSE);
  g_time += 0.01666666666666666666666666666666666666666666666;
  show_fps();
}

int main(int argc, char *argv[]) {
  BOOL IsWindow = TRUE;
  if(gl.Init(InitWindow("glDevice Test.", WindowX, WindowY, IsWindow), ScreenX, ScreenY, IsWindow) == S_OK){
    func_init(&gl);
    while(ProcMsg()) {
      func_update(g_time);
      gl.Render(func_render);
      Sleep(0);
    }
    func_term(&gl);
  }
  gl.Term();
  return 0;
}

